﻿using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Formula
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox formula;
		private System.Windows.Forms.Button doSolve;
		private System.Windows.Forms.Label result;
		private System.Windows.Forms.Label label2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.formula = new System.Windows.Forms.TextBox();
			this.doSolve = new System.Windows.Forms.Button();
			this.result = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// formula
			// 
			this.formula.Location = new System.Drawing.Point(8, 16);
			this.formula.Name = "formula";
			this.formula.Size = new System.Drawing.Size(384, 20);
			this.formula.TabIndex = 0;
			this.formula.Text = "(2*(4+3*2))/(5-1)";
			// 
			// doSolve
			// 
			this.doSolve.Location = new System.Drawing.Point(400, 40);
			this.doSolve.Name = "doSolve";
			this.doSolve.TabIndex = 1;
			this.doSolve.Text = "هه‌ڵیهێنه";
			this.doSolve.Click += new System.EventHandler(this.doSolve_Click);
			// 
			// result
			// 
			this.result.Location = new System.Drawing.Point(288, 40);
			this.result.Name = "result";
			this.result.TabIndex = 2;
			this.result.Text = "5";
			this.result.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(400, 16);
			this.label2.Name = "label2";
			this.label2.TabIndex = 3;
			this.label2.Text = "فۆرمۆڵ";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(504, 77);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.result);
			this.Controls.Add(this.doSolve);
			this.Controls.Add(this.formula);
			this.Font = new System.Drawing.Font("Tahoma", 8F);
			this.Name = "Form1";
			this.Text = "zKurd.org";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void doSolve_Click(object sender, System.EventArgs e)
		{
			string f = formula.Text;
			string inner = FindInnerFormula(f);
			while (inner != null)
			{
				f = f.Replace(string.Concat("(", inner, ")"), Evaluate(inner).ToString());
				inner = FindInnerFormula(f);
			}
			result.Text = Evaluate(f).ToString();
		}
		
		private string FindInnerFormula(string formula)
		{
			int posL, posR = formula.IndexOf(')');
			if (posR > 0)
			{
				posL = formula.LastIndexOf('(', posR);
				return formula.Substring(posL + 1, posR - posL - 1);
			}
			return null;
		}
		private double Evaluate(string f)
		{
			if (f.IndexOf('+') < 0)
				return EvaluateMinus(f);
			string[] pluses = f.Split(new char[]{'+'});
			double res = 0;
			for (int i = 0; i < pluses.Length; i++)
				res += EvaluateMinus(pluses[i]);
			return res;
		}
		private double EvaluateMinus(string plus)
		{
			if (plus.IndexOf('-') < 0)
				return EvaluateMul(plus);
			if (plus.StartsWith("-"))
				plus = string.Concat("0", plus);
			string[] minuses = plus.Split(new char[]{'-'});
			double res = EvaluateMul(minuses[0]);
			for (int i = 1; i < minuses.Length; i++)
				res -= EvaluateMul(minuses[i]);
			return res;
		}
		private double EvaluateMul(string minus)
		{
			if (minus.IndexOf('*') < 0)
				return EvaluateDiv(minus);
			string[] muls = minus.Split(new char[]{'*'});
			double res = 1;
			for (int i = 0; i < muls.Length; i++)
				res *= EvaluateDiv(muls[i]);
			return res;
		}
		private double EvaluateDiv(string mul)
		{
			if (mul.IndexOf('/') < 0)
				return EvaluateMax(mul);
			string[] divs = mul.Split(new char[]{'/'});
			double res = EvaluateMax(divs[0]);
			for (int i = 1; i < divs.Length; i++)
				res /= EvaluateMax(divs[i]);
			return res;
		}
		private double EvaluateMax(string div)
		{
			if (div.IndexOf('^') < 0)
				return EvaluateMin(div);
			string[] maxs = div.Split(new char[]{'^'});
			double res = double.MinValue;
			for (int i = 0; i < maxs.Length; i++)
			{
				double resi = EvaluateMin(maxs[i]);
				if (res < resi)
					res = resi;
			}
			return res;
		}
		private double EvaluateMin(string max)
		{
			if (max.IndexOf('~') < 0)
				return Convert.ToDouble(max);
			string[] mins = max.Split(new char[]{'~'});
			double res = Convert.ToDouble(mins[0]);
			for (int i = 1; i < mins.Length; i++)
				if (res > Convert.ToDouble(mins[i]))
					res = Convert.ToDouble(mins[i]);
			return res;
		}
	}
}
